// Class: haxe.iterators.DynamicAccessKeyValueIterator

var $global = typeof window != "undefined" ? window : typeof global != "undefined" ? global : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = require("./../../hxClasses_stub").default;
var $hxEnums = require("./../../hxEnums_stub").default;
var $import = require("./../../import_stub").default;
function Reflect() {return require("./../../Reflect");}

// Constructor

var DynamicAccessKeyValueIterator = function(access) {
	this.access = access;
	this.keys = (Reflect().default).fields(access);
	this.index = 0;
}

// Meta

DynamicAccessKeyValueIterator.__name__ = "haxe.iterators.DynamicAccessKeyValueIterator";
DynamicAccessKeyValueIterator.__isInterface__ = false;
DynamicAccessKeyValueIterator.prototype = {
	hasNext: function() {
		return this.index < this.keys.length;
	},
	next: function() {
		var key = this.keys[this.index++];
		return { value : this.access[key], key : key};
	}
};
DynamicAccessKeyValueIterator.prototype.__class__ = DynamicAccessKeyValueIterator.prototype.constructor = $hxClasses["haxe.iterators.DynamicAccessKeyValueIterator"] = DynamicAccessKeyValueIterator;

// Init



// Statics




// Export

exports.default = DynamicAccessKeyValueIterator;