package starling.assets {
import starling.textures.TextureOptions;
/**
 *  The description of an asset to be created by an AssetFactory. 
 * @externs
 */
public class AssetReference {
	/**
	 *  Creates a new instance with the given data, which is typically some kind of file
	 *      *  reference / URL or an instance of an asset class. If 'data' contains an URL, an
	 *      *  equivalent value will be assigned to the 'url' property. 
	 */
	public function AssetReference(data:*) {}
	/**
	 *  The name with which the asset should be added to the AssetManager. 
	 */
	public function get name():String { return null; }
	public function set name(value:String):void {}
	/**
	 *  The url from which the asset needs to be / has been loaded. 
	 */
	public function get url():String { return null; }
	public function set url(value:String):void {}
	/**
	 *  The raw data of the asset. This property often contains an URL; when it's passed
	 *      *  to an AssetFactory, loading has already completed, and the property contains a
	 *      *  ByteArray with the loaded data. 
	 */
	public function get data():* { return null; }
	public function set data(value:*):void {}
	/**
	 *  The mime type of the asset, if loaded from a server. 
	 */
	public function get mimeType():String { return null; }
	public function set mimeType(value:String):void {}
	/**
	 *  The file extension of the asset, if the filename or URL contains one. 
	 */
	public function get extension():String { return null; }
	public function set extension(value:String):void {}
	/**
	 *  The TextureOptions describing how to create a texture, if the asset references one. 
	 */
	public function get textureOptions():starling.textures.TextureOptions { return null; }
	public function set textureOptions(value:starling.textures.TextureOptions):void {}
}
}
