import AssetReference from "./AssetReference";
import AssetFactoryHelper from "./AssetFactoryHelper";
import AssetFactory from "./AssetFactory";
declare namespace starling.assets {
	/**
	 *  This AssetFactory forwards ByteArrays to the AssetManager. It's the fallback when
	 *  *  no other factory can handle an asset reference (default priority: -100). 
	 */
	export class ByteArrayFactory extends AssetFactory {
		/**
		 *  Creates a new instance. 
		 */
		constructor();
		/**
		 *  @inheritDoc 
		 */
		override canHandle(reference: AssetReference): boolean;
		/**
		 *  @inheritDoc 
		 */
		override create(reference: AssetReference, helper: AssetFactoryHelper, onComplete: (arg0: string, arg1: any) => void, onError: (arg0: string) => void): void;
	}
}
export default starling.assets.ByteArrayFactory;