import AssetReference from "./AssetReference";
import AssetFactoryHelper from "./AssetFactoryHelper";
import AssetFactory from "./AssetFactory";
declare namespace starling.assets {
	/**
	 *  This AssetFactory creates XML assets, texture atlases and bitmap fonts. 
	 */
	export class XmlFactory extends AssetFactory {
		/**
		 *  Creates a new instance. 
		 */
		constructor();
		/**
		 *  Returns true if mime type or extension fit for XML data, or if the data starts
		 *      *  with a "&lt;" character. 
		 */
		override canHandle(reference: AssetReference): boolean;
		/**
		 *  Creates the XML asset and passes it to 'onComplete'. If the XML contains a
		 *      *  TextureAtlas or a BitmapFont, adds suitable post processors. 
		 */
		override create(reference: AssetReference, helper: AssetFactoryHelper, onComplete: (arg0: string, arg1: any) => void, onError: (arg0: string) => void): void;
	}
}
export default starling.assets.XmlFactory;