package starling.core {
import starling.display.Sprite;
import starling.display.DisplayObject;
import openfl.geom.Rectangle;
/**
 *  A small, lightweight box that displays the current framerate, memory consumption and
 *  *  the number of draw calls per frame. The display is updated automatically once per frame. 
 * @externs
 */
public class StatsDisplay extends starling.display.Sprite {
	/**
	 *  Creates a new Statistics Box. 
	 */
	public function StatsDisplay() {
		super();
	}
	/**
	 *  Updates the displayed values. 
	 */
	public function update():void {}
	/**
	 *  @private 
	 */
	override public function getBounds(targetSpace:starling.display.DisplayObject, out:openfl.geom.Rectangle = undefined):openfl.geom.Rectangle { return null; }
	/**
	 *  The number of Stage3D draw calls per second. 
	 */
	public function get drawCount():int { return 0; }
	public function set drawCount(value:int):void {}
	/**
	 *  The current frames per second (updated twice per second). 
	 */
	public function get fps():Number { return 0; }
	public function set fps(value:Number):void {}
	/**
	 *  The currently required system memory in MB. 
	 */
	public function get memory():Number { return 0; }
	public function set memory(value:Number):void {}
	/**
	 *  The currently used graphics memory in MB. 
	 */
	public function get gpuMemory():Number { return 0; }
	public function set gpuMemory(value:Number):void {}
	/**
	 *  Indicates if the number of skipped frames should be shown. 
	 */
	public function get showSkipped():Boolean { return false; }
	public function set showSkipped(value:Boolean):void {}
}
}
