import Sprite from "../display/Sprite";
import DisplayObject from "../display/DisplayObject";
import Rectangle from "openfl/geom/Rectangle";
declare namespace starling.core {
	/**
	 *  A small, lightweight box that displays the current framerate, memory consumption and
	 *  *  the number of draw calls per frame. The display is updated automatically once per frame. 
	 */
	export class StatsDisplay extends Sprite {
		/**
		 *  Creates a new Statistics Box. 
		 */
		constructor();
		/**
		 *  Updates the displayed values. 
		 */
		update(): void;
		/**
		 *  @private 
		 */
		override getBounds(targetSpace: DisplayObject, out?: Rectangle): Rectangle;
		/**
		 *  The number of Stage3D draw calls per second. 
		 */
		get drawCount(): number;
		set drawCount(value: number)
		/**
		 *  The current frames per second (updated twice per second). 
		 */
		get fps(): number;
		set fps(value: number)
		/**
		 *  The currently required system memory in MB. 
		 */
		get memory(): number;
		set memory(value: number)
		/**
		 *  The currently used graphics memory in MB. 
		 */
		get gpuMemory(): number;
		set gpuMemory(value: number)
		/**
		 *  Indicates if the number of skipped frames should be shown. 
		 */
		get showSkipped(): boolean;
		set showSkipped(value: boolean)
	}
}
export default starling.core.StatsDisplay;