declare namespace starling.display {
	/**
	 *  A class that provides constant values for the states of the Button class. 
	 */
	export class ButtonState {
		/**
		 *  The button's default state. 
		 */
		static readonly UP = "up";
		/**
		 *  The button is pressed. 
		 */
		static readonly DOWN = "down";
		/**
		 *  The mouse hovers over the button. 
		 */
		static readonly OVER = "over";
		/**
		 *  The button was disabled altogether. 
		 */
		static readonly DISABLED = "disabled";
		/**
		 *  Indicates whether the given state string is valid. 
		 */
		static isValid(state: string): boolean;
	}
}
export default starling.display.ButtonState;