package starling.display {
import starling.geom.Polygon;
import openfl.geom.Point;
/**
 *  A display object supporting basic vector drawing functionality. In its current state,
 *  *  the main use of this class is to provide a range of forms that can be used as masks.
 *  
 * @externs
 */
public class Canvas extends starling.display.DisplayObjectContainer {
	/**
	 *  Creates a new (empty) Canvas. Call one or more of the 'draw' methods to add content. 
	 */
	public function Canvas() {
		super();
	}
	/**
	 *  @inheritDoc 
	 */
	override public function dispose():void {}
	/**
	 *  @inheritDoc 
	 */
	override public function hitTest(localPoint:openfl.geom.Point):starling.display.DisplayObject { return null; }
	/**
	 *  Draws a circle.
	 * 	 *
	 * 	 * @param x         x-coordinate of center point
	 * 	 * @param y         y-coordinate of center point
	 * 	 * @param radius    radius of circle
	 * 	 * @param numSides  the number of lines used to draw the circle.
	 * 	 *                  If you don't pass anything, Starling will pick a reasonable value.
	 * 	 
	 */
	public function drawCircle(x:Number, y:Number, radius:Number, numSides:int = undefined):void {}
	/**
	 *  Draws an ellipse.
	 * 	 *
	 * 	 * @param x         x-coordinate of bounding box
	 * 	 * @param y         y-coordinate of bounding box
	 * 	 * @param width     width of the ellipse
	 * 	 * @param height    height of the ellipse
	 * 	 * @param numSides  the number of lines used to draw the ellipse.
	 * 	 *                  If you don't pass anything, Starling will pick a reasonable value.
	 * 	 
	 */
	public function drawEllipse(x:Number, y:Number, width:Number, height:Number, numSides:int = undefined):void {}
	/**
	 *  Draws a rectangle. 
	 */
	public function drawRectangle(x:Number, y:Number, width:Number, height:Number):void {}
	/**
	 *  Draws an arbitrary polygon. 
	 */
	public function drawPolygon(polygon:starling.geom.Polygon):void {}
	/**
	 *  Specifies a simple one-color fill that subsequent calls to drawing methods
	 *      * (such as <code>drawCircle()</code>) will use. 
	 */
	public function beginFill(color:int = undefined, alpha:Number = undefined):void {}
	/**
	 *  Resets the color to 'white' and alpha to '1'. 
	 */
	public function endFill():void {}
	/**
	 *  Removes all existing vertices. 
	 */
	public function clear():void {}
}
}
