package starling.events {
/**
 *  Stores the information about raw touches in a pool of object instances.
 *  *
 *  *  <p>This class is purely for internal use of the TouchProcessor.</p>
 *  
 * @externs
 */
public class TouchData {
	function TouchData() {}
	/**
	 *  Creates a new TouchData instance with the given properties or returns one from
	 *         *  the object pool. 
	 */
	public static function fromPool(touchID:int, phase:String, globalX:Number, globalY:Number, pressure:Number = undefined, width:Number = undefined, height:Number = undefined):starling.events.TouchData { return null; }
	/**
	 *  Moves an instance back into the pool. 
	 */
	public static function toPool(rawTouch:starling.events.TouchData):void {}
	/**
	 *  The identifier of a touch. '0' for mouse events, an increasing number for touches. 
	 */
	public var id:int;
	/**
	 *  The current phase the touch is in. @see TouchPhase 
	 */
	public var phase:String;
	/**
	 *  The x-position of the touch in stage coordinates. 
	 */
	public var globalX:Number;
	/**
	 *  The y-position of the touch in stage coordinates. 
	 */
	public var globalY:Number;
	/**
	 *  A value between 0.0 and 1.0 indicating force of the contact with the device.
	 *      *  If the device does not support detecting the pressure, the value is 1.0. 
	 */
	public var pressure:Number;
	/**
	 *  Width of the contact area.
	 *      *  If the device does not support detecting the pressure, the value is 1.0. 
	 */
	public var width:Number;
	/**
	 *  Height of the contact area.
	 *      *  If the device does not support detecting the pressure, the value is 1.0. 
	 */
	public var height:Number;
}
}
