package starling.filters {
import starling.textures.Texture;
import starling.rendering.Painter;
/**
 *  The FilterChain allows you to combine several filters into one. The filters will be
 *  *  processed in the given order, the number of draw calls per filter adding up.
 *  *  Just like conventional filters, a chain may be attached to any display object.
 *  
 * @externs
 */
public class FilterChain extends starling.filters.FragmentFilter {
	/**
	 *  Creates a new chain with the given filters. 
	 */
	public function FilterChain(args:Array = undefined) {
		super();
	}
	/**
	 *  Disposes the filter chain itself as well as all contained filters. 
	 */
	override public function dispose():void {}
	/**
	 *  @private 
	 */
	override public function process(painter:starling.rendering.Painter, helper:starling.filters.IFilterHelper, input0:starling.textures.Texture = undefined, input1:starling.textures.Texture = undefined, input2:starling.textures.Texture = undefined, input3:starling.textures.Texture = undefined):starling.textures.Texture { return null; }
	/**
	 *  Returns the filter at a certain index. If you pass a negative index,
	 *      *  '-1' will return the last filter, '-2' the second to last filter, etc. 
	 */
	public function getFilterAt(index:int):starling.filters.FragmentFilter { return null; }
	/**
	 *  Adds a filter to the chain. It will be appended at the very end. 
	 */
	public function addFilter(filter:starling.filters.FragmentFilter):void {}
	/**
	 *  Adds a filter to the chain at the given index. 
	 */
	public function addFilterAt(filter:starling.filters.FragmentFilter, index:int):void {}
	/**
	 *  Removes a filter from the chain. If the filter is not part of the chain,
	 *      *  nothing happens. If requested, the filter will be disposed right away. 
	 */
	public function removeFilter(filter:starling.filters.FragmentFilter, dispose:Boolean = undefined):starling.filters.FragmentFilter { return null; }
	/**
	 *  Removes the filter at a certain index. The indices of any subsequent filters
	 *      *  are decremented. If requested, the filter will be disposed right away. 
	 */
	public function removeFilterAt(index:int, dispose:Boolean = undefined):starling.filters.FragmentFilter { return null; }
	/**
	 *  Returns the index of a filter within the chain, or "-1" if it is not found. 
	 */
	public function getFilterIndex(filter:starling.filters.FragmentFilter):int { return 0; }
	/**
	 *  Indicates the current chain length. 
	 */
	public function get numFilters():int { return 0; }
}
}
