package starling.filters {
import starling.textures.Texture;
import starling.display.DisplayObject;
import openfl.geom.Rectangle;
import openfl.geom.Matrix3D;
/**
 *  @private
 *  *
 *  *  This class manages texture creation, pooling and disposal of all textures
 *  *  during filter processing.
 *  
 * @externs
 */
public class FilterHelper implements starling.filters.IFilterHelper {
	/**
	 *  Creates a new, empty instance. 
	 */
	public function FilterHelper(textureFormat:String = undefined) {}
	/**
	 *  Purges the pool. 
	 */
	public function dispose():void {}
	/**
	 *  Starts a new round of rendering. If <code>numPasses</code> is greater than zero, each
	 *      *  <code>getTexture()</code> call will be counted as one pass; the final pass will then
	 *      *  return <code>null</code> instead of a texture, to indicate that this pass should be
	 *      *  rendered to the back buffer.
	 *      
	 */
	public function start(numPasses:int, drawLastPassToBackBuffer:Boolean):void {}
	/**
	 *  @inheritDoc 
	 */
	public function getTexture(resolution:Number = undefined):starling.textures.Texture { return null; }
	/**
	 *  @inheritDoc 
	 */
	public function putTexture(texture:starling.textures.Texture):void {}
	/**
	 *  Purges the pool and disposes all textures. 
	 */
	public function purge():void {}
	/**
	 *  The projection matrix that was active when the filter started processing. 
	 */
	public function get projectionMatrix3D():openfl.geom.Matrix3D { return null; }
	public function set projectionMatrix3D(value:openfl.geom.Matrix3D):void {}
	/**
	 *  The render target that was active when the filter started processing. 
	 */
	public function get renderTarget():starling.textures.Texture { return null; }
	public function set renderTarget(value:starling.textures.Texture):void {}
	/**
	 *  The clipping rectangle that was active when the filter started processing. 
	 */
	public function get clipRect():openfl.geom.Rectangle { return null; }
	public function set clipRect(value:openfl.geom.Rectangle):void {}
	/**
	 *  @inheritDoc 
	 */
	public function get targetBounds():openfl.geom.Rectangle { return null; }
	public function set targetBounds(value:openfl.geom.Rectangle):void {}
	/**
	 *  @inheritDoc 
	 */
	public function get target():starling.display.DisplayObject { return null; }
	public function set target(value:starling.display.DisplayObject):void {}
	/**
	 *  The scale factor of the returned textures. 
	 */
	public function get textureScale():Number { return 0; }
	public function set textureScale(value:Number):void {}
	/**
	 *  The texture format of the returned textures. @default BGRA 
	 */
	public function get textureFormat():String { return null; }
	public function set textureFormat(value:String):void {}
}
}
