package starling.rendering {
import openfl.utils.ByteArray;
import openfl.display3D.Context3D;
/**
 *  A Program represents a pair of a fragment- and vertex-shader.
 *  *
 *  *  <p>This class is a convenient replacement for Stage3Ds "Program3D" class. Its main
 *  *  advantage is that it survives a context loss; furthermore, it makes it simple to
 *  *  create a program from AGAL source without having to deal with the assembler.</p>
 *  *
 *  *  <p>It is recommended to store programs in Starling's "Painter" instance via the methods
 *  *  <code>registerProgram</code> and <code>getProgram</code>. That way, your programs may
 *  *  be shared among different display objects or even Starling instances.</p>
 *  *
 *  *  @see Painter
 *  
 * @externs
 */
public class Program {
	/**
	 *  Creates a program from the given AGAL (Adobe Graphics Assembly Language) bytecode. 
	 */
	public function Program(vertexShader:openfl.utils.ByteArray, fragmentShader:openfl.utils.ByteArray) {}
	/**
	 *  Creates a new Program instance from AGAL assembly language. 
	 */
	public static function fromSource(vertexShader:String, fragmentShader:String, agalVersion:int = undefined):starling.rendering.Program { return null; }
	/**
	 *  Disposes the internal Program3D instance. 
	 */
	public function dispose():void {}
	/**
	 *  Activates the program on the given context. If you don't pass a context, the current
	 *      *  Starling context will be used. 
	 */
	public function activate(context:openfl.display3D.Context3D = undefined):void {}
}
}
