package starling.text {
import starling.textures.Texture;
import starling.display.Image;
/**
 *  A BitmapChar contains the information about one char of a bitmap font.  
 *  *  <em>You don't have to use this class directly in most cases. 
 *  *  The TextField class contains methods that handle bitmap fonts for you.</em>    
 *  
 * @externs
 */
public class BitmapChar {
	/**
	 *  Creates a char with a texture and its properties. 
	 */
	public function BitmapChar(id:int, texture:starling.textures.Texture, xOffset:Number, yOffset:Number, xAdvance:Number) {}
	/**
	 *  Adds kerning information relative to a specific other character ID. 
	 */
	public function addKerning(charID:int, amount:Number):void {}
	/**
	 *  Retrieve kerning information relative to the given character ID. 
	 */
	public function getKerning(charID:int):Number { return 0; }
	/**
	 *  Creates an image of the char. 
	 */
	public function createImage():starling.display.Image { return null; }
	/**
	 *  The unicode ID of the char. 
	 */
	public function get charID():int { return 0; }
	/**
	 *  The number of points to move the char in x direction on character arrangement. 
	 */
	public function get xOffset():Number { return 0; }
	/**
	 *  The number of points to move the char in y direction on character arrangement. 
	 */
	public function get yOffset():Number { return 0; }
	/**
	 *  The number of points the cursor has to be moved to the right for the next char. 
	 */
	public function get xAdvance():Number { return 0; }
	/**
	 *  The texture of the character. 
	 */
	public function get texture():starling.textures.Texture { return null; }
	/**
	 *  The width of the character in points. 
	 */
	public function get width():Number { return 0; }
	/**
	 *  The height of the character in points. 
	 */
	public function get height():Number { return 0; }
}
}
