declare namespace starling.text {
	/**
	 *  This class is an enumeration of constant values used in setting the 
	 *  *  autoSize property of the TextField class. 
	 */
	export class TextFieldAutoSize {
		/**
		 *  No auto-sizing will happen. 
		 */
		static readonly NONE = "none";
		/**
		 *  The text field will grow/shrink sidewards; no line-breaks will be added.
		 *      * The height of the text field remains unchanged. 
		 */
		static readonly HORIZONTAL = "horizontal";
		/**
		 *  The text field will grow/shrink downwards, adding line-breaks when necessary.
		 *      * The width of the text field remains unchanged. 
		 */
		static readonly VERTICAL = "vertical";
		/**
		 *  The text field will grow to the right and bottom; no line-breaks will be added. 
		 */
		static readonly BOTH_DIRECTIONS = "bothDirections";
	}
}
export default starling.text.TextFieldAutoSize;