package starling.text {
import starling.events.EventDispatcher;
import openfl.text.TextFormat;
/**
 *  Dispatched when any property of the instance changes. 
 * @externs
 */
public class TextFormat extends starling.events.EventDispatcher {
	/**
	 *  Creates a new TextFormat instance with the given properties. 
	 */
	public function TextFormat(font:String = undefined, size:Number = undefined, color:int = undefined, horizontalAlign:String = undefined, verticalAlign:String = undefined) {
		super();
	}
	/**
	 *  Copies all properties from another TextFormat instance. 
	 */
	public function copyFrom(format:starling.text.TextFormat):void {}
	/**
	 *  Creates a clone of this instance. 
	 */
	public function clone():starling.text.TextFormat { return null; }
	/**
	 *  Sets the most common properties at once. 
	 */
	public function setTo(font:String = undefined, size:Number = undefined, color:int = undefined, horizontalAlign:String = undefined, verticalAlign:String = undefined):void {}
	/**
	 *  Converts the Starling TextFormat instance to a Flash TextFormat. 
	 */
	public function toNativeFormat(out:openfl.text.TextFormat = undefined):openfl.text.TextFormat { return null; }
	/**
	 *  The name of the font. TrueType fonts will be looked up from embedded fonts and
	 *      *  system fonts; bitmap fonts must be registered at the TextField class first.
	 *      *  Beware: If you loaded an embedded font at runtime, you must call
	 *      *  <code>TextField.updateEmbeddedFonts()</code> for Starling to recognize it.
	 *      
	 */
	public function get font():String { return null; }
	public function set font(value:String):void {}
	/**
	 *  The size of the font. For bitmap fonts, use <code>BitmapFont.NATIVE_SIZE</code> for
	 *      *  the original size. 
	 */
	public function get size():Number { return 0; }
	public function set size(value:Number):void {}
	/**
	 *  The color of the text. Note that bitmap fonts should be exported in plain white so
	 *      *  that tinting works correctly. If your bitmap font contains colors, set this property
	 *      *  to <code>Color.WHITE</code> to get the desired result. @default black 
	 */
	public function get color():int { return 0; }
	public function set color(value:int):void {}
	/**
	 *  Indicates whether the text is bold. @default false 
	 */
	public function get bold():Boolean { return false; }
	public function set bold(value:Boolean):void {}
	/**
	 *  Indicates whether the text is italicized. @default false 
	 */
	public function get italic():Boolean { return false; }
	public function set italic(value:Boolean):void {}
	/**
	 *  Indicates whether the text is underlined. @default false 
	 */
	public function get underline():Boolean { return false; }
	public function set underline(value:Boolean):void {}
	/**
	 *  The horizontal alignment of the text. @default center
	 *      *  @see starling.utils.Align 
	 */
	public function get horizontalAlign():String { return null; }
	public function set horizontalAlign(value:String):void {}
	/**
	 *  The vertical alignment of the text. @default center
	 *      *  @see starling.utils.Align 
	 */
	public function get verticalAlign():String { return null; }
	public function set verticalAlign(value:String):void {}
	/**
	 *  Indicates whether kerning is enabled. Kerning adjusts the pixels between certain
	 *      *  character pairs to improve readability. @default true 
	 */
	public function get kerning():Boolean { return false; }
	public function set kerning(value:Boolean):void {}
	/**
	 *  The amount of vertical space (called 'leading') between lines. @default 0 
	 */
	public function get leading():Number { return 0; }
	public function set leading(value:Number):void {}
	/**
	 *  A number representing the amount of space that is uniformly distributed between all characters. @default 0 
	 */
	public function get letterSpacing():Number { return 0; }
	public function set letterSpacing(value:Number):void {}
}
}
