package starling.text {
import starling.events.EventDispatcher;
/**
 *  Dispatched when any property of the instance changes. 
 * @externs
 */
public class TextOptions extends starling.events.EventDispatcher {
	/**
	 *  Creates a new TextOptions instance with the given properties. 
	 */
	public function TextOptions(wordWrap:Boolean = undefined, autoScale:Boolean = undefined) {
		super();
	}
	/**
	 *  Copies all properties from another TextOptions instance. 
	 */
	public function copyFrom(options:starling.text.TextOptions):void {}
	/**
	 *  Creates a clone of this instance. 
	 */
	public function clone():starling.text.TextOptions { return null; }
	/**
	 *  Indicates if the text should be wrapped at word boundaries if it does not fit into
	 *      *  the TextField otherwise. @default true 
	 */
	public function get wordWrap():Boolean { return false; }
	public function set wordWrap(value:Boolean):void {}
	/**
	 *  Specifies the type of auto-sizing set on the TextField. Custom text compositors may
	 *      *  take this into account, though the basic implementation (done by the TextField itself)
	 *      *  is often sufficient: it passes a very big size to the <code>fillMeshBatch</code>
	 *      *  method and then trims the result to the actually used area. @default none 
	 */
	public function get autoSize():String { return null; }
	public function set autoSize(value:String):void {}
	/**
	 *  Indicates whether the font size is automatically reduced if the complete text does
	 *      *  not fit into the TextField. @default false 
	 */
	public function get autoScale():Boolean { return false; }
	public function set autoScale(value:Boolean):void {}
	/**
	 *  Indicates if text should be interpreted as HTML code. For a description
	 *      *  of the supported HTML subset, refer to the classic Flash 'TextField' documentation.
	 *      *  Beware: Only supported for TrueType fonts. @default false 
	 */
	public function get isHtmlText():Boolean { return false; }
	public function set isHtmlText(value:Boolean):void {}
	/**
	 *  The scale factor of any textures that are created during text composition.
	 *      *  @default Starling.contentScaleFactor 
	 */
	public function get textureScale():Number { return 0; }
	public function set textureScale(value:Number):void {}
	/**
	 *  The Context3DTextureFormat of any textures that are created during text composition.
	 *      *  @default Context3DTextureFormat.BGRA_PACKED 
	 */
	public function get textureFormat():String { return null; }
	public function set textureFormat(value:String):void {}
	/**
	 *  The padding (in points) that's added to the sides of text that's rendered to a Bitmap.
	 *      *  If your text is truncated on the sides (which may happen if the font returns incorrect
	 *      *  bounds), padding can make up for that. Value must be positive. @default 0.0 
	 */
	public function get padding():Number { return 0; }
	public function set padding(value:Number):void {}
}
}
