import TextOptions from "./TextOptions";
import TextFormat from "./TextFormat";
import ITextCompositor from "./ITextCompositor";
import MeshStyle from "../styles/MeshStyle";
import MeshBatch from "../display/MeshBatch";
declare namespace starling.text {
	/**
	 *  This text compositor uses a Flash TextField to render system- or embedded fonts into
	 *  *  a texture.
	 *  *
	 *  *  <p>You typically don't have to instantiate this class. It will be used internally by
	 *  *  Starling's text fields.</p>
	 *  
	 */
	export class TrueTypeCompositor implements ITextCompositor {
		/**
		 *  Creates a new TrueTypeCompositor instance. 
		 */
		constructor();
		/**
		 *  @inheritDoc 
		 */
		dispose(): void;
		/**
		 *  @inheritDoc 
		 */
		fillMeshBatch(meshBatch: MeshBatch, width: number, height: number, text: string, format: TextFormat, options?: TextOptions): void;
		/**
		 *  @inheritDoc 
		 */
		clearMeshBatch(meshBatch: MeshBatch): void;
		/**
		 *  @private 
		 */
		getDefaultMeshStyle(previousStyle: MeshStyle, format: TextFormat, options: TextOptions): MeshStyle;
	}
}
export default starling.text.TrueTypeCompositor;