package starling.textures {
import openfl.utils.ByteArray;
/**
 *  A parser for the ATF data format. 
 * @externs
 */
public class AtfData {
	/**
	 *  Create a new instance by parsing the given byte array. 
	 */
	public function AtfData(data:openfl.utils.ByteArray) {}
	/**
	 *  Checks the first 3 bytes of the data for the 'ATF' signature. 
	 */
	public static function isAtfData(data:openfl.utils.ByteArray):Boolean { return false; }
	/**
	 *  The texture format. @see flash.display3D.textures.Context3DTextureFormat 
	 */
	public function get format():String { return null; }
	/**
	 *  The width of the texture in pixels. 
	 */
	public function get width():int { return 0; }
	/**
	 *  The height of the texture in pixels. 
	 */
	public function get height():int { return 0; }
	/**
	 *  The number of encoded textures. '1' means that there are no mip maps. 
	 */
	public function get numTextures():int { return 0; }
	/**
	 *  Indicates if the ATF data encodes a cube map. Not supported by Starling! 
	 */
	public function get isCubeMap():Boolean { return false; }
	/**
	 *  The actual byte data, including header. 
	 */
	public function get data():openfl.utils.ByteArray { return null; }
}
}
