declare namespace starling.textures {
	/**
	 *  A class that provides constant values for the possible smoothing algorithms of a texture. 
	 */
	export class TextureSmoothing {
		/**
		 *  No smoothing, also called "Nearest Neighbor". Pixels will scale up as big rectangles. 
		 */
		static readonly NONE = "none";
		/**
		 *  Bilinear filtering. Creates smooth transitions between pixels. 
		 */
		static readonly BILINEAR = "bilinear";
		/**
		 *  Trilinear filtering. Highest quality by taking the next mip map level into account. 
		 */
		static readonly TRILINEAR = "trilinear";
		/**
		 *  Determines whether a smoothing value is valid. 
		 */
		static isValid(smoothing: string): boolean;
	}
}
export default starling.textures.TextureSmoothing;