declare namespace starling.utils {
	/**
	 *  A class that provides constant values for horizontal and vertical alignment of objects. 
	 */
	export class Align {
		/**
		 *  @private 
		 */
		static readonly LEFT = "left";
		/**
		 *  Horizontal right alignment. 
		 */
		static readonly RIGHT = "right";
		/**
		 *  Vertical top alignment. 
		 */
		static readonly TOP = "top";
		/**
		 *  Vertical bottom alignment. 
		 */
		static readonly BOTTOM = "bottom";
		/**
		 *  Centered alignment. 
		 */
		static readonly CENTER = "center";
		/**
		 *  Indicates whether the given alignment string is valid. 
		 */
		static isValid(align: string): boolean;
		/**
		 *  Indicates if the given string is a valid horizontal alignment. 
		 */
		static isValidHorizontal(align: string): boolean;
		/**
		 *  Indicates if the given string is a valid vertical alignment. 
		 */
		static isValidVertical(align: string): boolean;
	}
}
export default starling.utils.Align;