import ByteArray from "openfl/utils/ByteArray";
declare namespace starling.utils {
	/**
	 *  A utility class containing methods related to the ByteArray class. 
	 */
	export class ByteArrayUtil {
		/**
		 *  @private 
		 */
		static startsWithString(bytes: ByteArray, string: string): boolean;
		/**
		 *  Figures out if a byte array starts with the given bytes.
		 *      *  Pass an array that contains integers in the range 0-255. 
		 */
		static startsWithBytes(byteArray: ByteArray, firstBytes: Array<number>): boolean;
		/**
		 *  Compares the range of bytes within two byte arrays. 
		 */
		static compareByteArrays(a: ByteArray, indexA: number, b: ByteArray, indexB: number, numBytes?: number): boolean;
	}
}
export default starling.utils.ByteArrayUtil;