declare namespace starling.utils {
	/**
	 *  A class describing a range of vertices and indices, thus referencing a subset of a Mesh. 
	 */
	export class MeshSubset {
		/**
		 *  Creates a new MeshSubset. 
		 */
		constructor(vertexID?: number, numVertices?: number, indexID?: number, numIndices?: number);
		/**
		 *  The ID of the first vertex. 
		 */
		vertexID: number;
		/**
		 *  The total number of vertices. 
		 */
		numVertices: number;
		/**
		 *  The ID of the first index. 
		 */
		indexID: number;
		/**
		 *  The total number of indices. 
		 */
		numIndices: number;
		/**
		 *  Changes all properties at once.
		 *      *  Call without any arguments to reference a complete mesh. 
		 */
		setTo(vertexID?: number, numVertices?: number, indexID?: number, numIndices?: number): void;
	}
}
export default starling.utils.MeshSubset;