import VertexData from "../rendering/VertexData";
import IndexData from "../rendering/IndexData";
import DisplayObject from "../display/DisplayObject";
import Rectangle from "openfl/geom/Rectangle";
import Point from "openfl/geom/Point";
declare namespace starling.utils {
	/**
	 *  A utility class that helps with tasks that are common when working with meshes. 
	 */
	export class MeshUtil {
		/**
		 *  @private 
		 */
		static containsPoint(vertexData: VertexData, indexData: IndexData, point: Point): boolean;
		/**
		 *  Calculates the bounds of the given vertices in the target coordinate system. 
		 */
		static calculateBounds(vertexData: VertexData, sourceSpace: DisplayObject, targetSpace: DisplayObject, out?: Rectangle): Rectangle;
	}
}
export default starling.utils.MeshUtil;