package starling.utils {
import starling.events.EventDispatcher;
/**
 *  Dispatched when any property of the instance changes. 
 * @externs
 */
public class Padding extends starling.events.EventDispatcher {
	/**
	 *  Creates a new instance with the given properties. 
	 */
	public function Padding(left:Number = undefined, right:Number = undefined, top:Number = undefined, bottom:Number = undefined) {
		super();
	}
	/**
	 *  Sets all four values at once. 
	 */
	public function setTo(left:Number = undefined, right:Number = undefined, top:Number = undefined, bottom:Number = undefined):void {}
	/**
	 *  Sets all four sides to the same value. 
	 */
	public function setToUniform(value:Number):void {}
	/**
	 *  Sets left and right to <code>horizontal</code>, top and bottom to <code>vertical</code>. 
	 */
	public function setToSymmetric(horizontal:Number, vertical:Number):void {}
	/**
	 *  Copies all properties from another Padding instance.
	 *         *  Pass <code>null</code> to reset all values to zero. 
	 */
	public function copyFrom(padding:starling.utils.Padding):void {}
	/**
	 *  Creates a new instance with the exact same values. 
	 */
	public function clone():starling.utils.Padding { return null; }
	/**
	 *  The padding on the left side. 
	 */
	public function get left():Number { return 0; }
	public function set left(value:Number):void {}
	/**
	 *  The padding on the right side. 
	 */
	public function get right():Number { return 0; }
	public function set right(value:Number):void {}
	/**
	 *  The padding towards the top. 
	 */
	public function get top():Number { return 0; }
	public function set top(value:Number):void {}
	/**
	 *  The padding towards the bottom. 
	 */
	public function get bottom():Number { return 0; }
	public function set bottom(value:Number):void {}
}
}
