package starling.utils {
/**
 *  A utility class with methods related to the current platform and runtime. 
 * @externs
 */
public class SystemUtil {
	/**
	 *  Initializes the <code>ACTIVATE/DEACTIVATE</code> event handlers on the native
	 *         * application. This method is automatically called by the Starling constructor. 
	 */
	public static function initialize():void {}
	/**
	 *  Executes the given function with its arguments the next time the application is active.
	 *         * (If it <em>is</em> active already, the call will be executed right away.) 
	 */
	public static function executeWhenApplicationIsActive(call:Function, args:Array = undefined):void {}
	/**
	 *  Indicates if the application is currently active. On Desktop, this means that it has
	 *         * the focus; on mobile, that it is in the foreground. In the Flash Plugin, always
	 *         * returns true. 
	 */
	public static function get isApplicationActive():Boolean { return false; }
	/**
	 *  Indicates if the code is executed in an Adobe AIR runtime (true)
	 *         * or Flash plugin/projector (false). 
	 */
	public static function get isAIR():Boolean { return false; }
	/**
	 *  Returns the Flash Player/AIR version string. The format of the version number is:
	 *         *  <em>majorVersion,minorVersion,buildNumber,internalBuildNumber</em>. 
	 */
	public static function get version():String { return null; }
	/**
	 *  Returns the three-letter platform string of the current system. These are
	 *         * the most common platforms: <code>WIN, MAC, LNX, IOS, AND, QNX</code>. Except for the
	 *         * last one, which indicates "Blackberry", all should be self-explanatory. 
	 */
	public static function get platform():String { return null; }
	public static function set platform(value:String):void {}
	/**
	 *  Returns the value of the 'initialWindow.depthAndStencil' node of the application
	 *         * descriptor, if this in an AIR app; otherwise always <code>true</code>. 
	 */
	public static function get supportsDepthAndStencil():Boolean { return false; }
	/**
	 *  Indicates if Context3D supports video textures. At the time of this writing,
	 *         * video textures are only supported on Windows, OS X and iOS, and only in AIR
	 *         * applications (not the Flash Player). 
	 */
	public static function get supportsVideoTexture():Boolean { return false; }
	/**
	 *  Updates the list of embedded fonts. To be called when a font is loaded at runtime. 
	 */
	public static function updateEmbeddedFonts():void {}
	/**
	 *  Figures out if an embedded font with the specified style is available.
	 *         *  The fonts are enumerated only once; if you load a font at runtime, be sure to call
	 *         *  'updateEmbeddedFonts' before calling this method.
	 *         *
	 *         *  @param fontName  the name of the font
	 *         *  @param bold      indicates if the font has a bold style
	 *         *  @param italic    indicates if the font has an italic style
	 *         *  @param fontType  the type of the font (one of the constants defined in the FontType class)
	 *         
	 */
	public static function isEmbeddedFont(fontName:String, bold:Boolean = undefined, italic:Boolean = undefined, fontType:String = undefined):Boolean { return false; }
	/**
	 *  Indicates if the code is executed on an iOS device, based on the <code>platform</code>
	 *         *  string. 
	 */
	public static function get isIOS():Boolean { return false; }
	/**
	 *  Indicates if the code is executed on an Android device, based on the
	 *         *  <code>platform</code> string. 
	 */
	public static function get isAndroid():Boolean { return false; }
	/**
	 *  Indicates if the code is executed on a Macintosh, based on the <code>platform</code>
	 *         *  string. 
	 */
	public static function get isMac():Boolean { return false; }
	/**
	 *  Indicates if the code is executed on Windows, based on the <code>platform</code>
	 *         *  string. 
	 */
	public static function get isWindows():Boolean { return false; }
	/**
	 *  Indicates if the code is executed on a Desktop computer with Windows, macOS or Linux
	 *         *  operating system. If the method returns 'false', it's probably a mobile device
	 *         *  or a Smart TV. 
	 */
	public static function get isDesktop():Boolean { return false; }
}
}
